
package me.zeus.MoarStuff;


import java.io.File;
import java.util.ArrayList;
import java.util.List;

import me.zeus.MoarStuff.Commands.BookCommand;
import me.zeus.MoarStuff.Commands.GiveCommand;
import me.zeus.MoarStuff.Events.*;
import me.zeus.MoarStuff.Resource.MSBow;
import me.zeus.MoarStuff.Resource.MSFood;
import me.zeus.MoarStuff.Resource.MSRod;
import me.zeus.MoarStuff.Util.BowReader;
import me.zeus.MoarStuff.Util.FoodReader;
import me.zeus.MoarStuff.Util.RodReader;

import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;



public class MoarStuff extends JavaPlugin {

    //======================================================================================//

    public List<MSRod> loadedRods = new ArrayList<MSRod>();
    public List<MSBow> loadedBows = new ArrayList<MSBow>();
    public List<MSFood> loadedFoods = new ArrayList<MSFood>();

    //======================================================================================//

    @Override
    public void onEnable()
    {
        getCommand("moarstuff").setExecutor(new BookCommand());
        getCommand("gimme").setExecutor(new GiveCommand(this));
        PluginManager pm = getServer().getPluginManager();
        pm.registerEvents(new PlayerFishEventHandler(this), this);
        pm.registerEvents(new ProjectileLaunchEventHandler(this), this);
        pm.registerEvents(new ProjectileHitEventHandler(this), this);
        pm.registerEvents(new CraftItemEventHandler(this), this);
        pm.registerEvents(new PlayerItemConsumeEventHandler(this), this);

        File dir = new File(getDataFolder() + "/rods");
        if (!dir.exists())
        {
            dir.mkdirs();
        }

        File dir2 = new File(getDataFolder() + "/bows");
        if (!dir2.exists())
        {
            dir2.mkdirs();
        }

        File dir3 = new File(getDataFolder() + "/foods");
        if (!dir3.exists())
        {
            dir3.mkdirs();
        }

        File dir4 = new File(getDataFolder() + "/drinks");
        if (!dir4.exists())
        {
            dir4.mkdirs();
        }

        loadRods();
        loadBows();
        loadFoods();
    }

    @Override
    public void onDisable()
    {

    }

    //======================================================================================//

    private void loadRods()
    {
        String path = getDataFolder() + "/rods";
        File dir = new File(path);
        String[] children = dir.list();
        if (children != null)
        {
            for (int i = 0; i < children.length; i++)
            {
                String filename = children[i];
                RodReader reader = new RodReader(this, new File(path + "/" + filename), filename);
                if (reader.loaded)
                {
                    loadedRods.add(reader.rod);
                    System.out.println("LOADED ROD: " + reader.rod.getName());
                } else
                {
                    System.out.println("FAILED TO LOAD ROD: " + reader.rod.getName());
                }
            }
        }
    }

    private void loadBows()
    {
        String path = getDataFolder() + "/bows";
        File dir = new File(path);
        String[] children = dir.list();
        if (children != null)
        {
            for (int i = 0; i < children.length; i++)
            {
                String filename = children[i];
                BowReader reader = new BowReader(this, new File(path + "/" + filename), filename);
                if (reader.loaded)
                {
                    loadedBows.add(reader.bow);
                    System.out.println("LOADED BOW: " + reader.bow.getName());
                } else
                {
                    System.out.println("FAILED TO LOAD BOW: " + reader.bow.getName());
                }
            }
        }
    }

    private void loadFoods()
    {
        String path = getDataFolder() + "/foods";
        File dir = new File(path);
        String[] children = dir.list();
        if (children != null)
        {
            for (int i = 0; i < children.length; i++)
            {
                String filename = children[i];
                FoodReader reader = new FoodReader(this, new File(path + "/" + filename), filename);
                if (reader.loaded)
                {
                    loadedFoods.add(reader.food);
                    System.out.println("LOADED FOOD: " + reader.food.getName());
                } else
                {
                    System.out.println("FAILED TO LOAD FOOD: " + reader.food.getName());
                }
            }
        }
    }
    //======================================================================================//

}
