
package me.zeus.MoarStuff.Resource;


import java.util.Arrays;
import java.util.List;

import me.zeus.MoarStuff.Enumeration.BowEffect;
import me.zeus.MoarStuff.Interfaces.BowMethod;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Effect;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.EnderPearl;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.WitherSkull;
import org.bukkit.event.entity.ProjectileHitEvent;
import org.bukkit.event.entity.ProjectileLaunchEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;



public class MSBow implements BowMethod {

    // =============================================================================================

    private String name;
    private String fileName;
    private String permission;
    private String key;

    private BowEffect effect;
    private ItemStack result = new ItemStack(Material.BOW, 1);
    private ShapedRecipe recipe;

    private Effect impactEffect;
    private Sound impactSound;
    private PotionEffectType impactPotion;
    @SuppressWarnings("unused")
    private List<Entity> toShootList;
    private EntityType toShoot;
    private EntityType toSpawnOnImpact;

    // =============================================================================================

    public MSBow(String name)
    {
        this.name = name;
        fileName = name;
    }

    // =============================================================================================

    public String getName()
    {
        return name;
    }

    public String getFileName()
    {
        return fileName;
    }

    public String getPermission()
    {
        return permission;
    }

    public String getSpecialKey()
    {
        return key;
    }

    public BowEffect getEffect()
    {
        return effect;
    }

    public ItemStack getResult()
    {
        return result;
    }

    public Effect getEffectOnImpact()
    {
        return impactEffect;
    }

    public Sound getSoundOnImpact()
    {
        return impactSound;
    }

    public ShapedRecipe getRecipe()
    {
        return recipe;
    }

    // =============================================================================================

    public void setName(String name)
    {
        this.name = name;
    }

    public void setFileName(String name)
    {
        fileName = name;
    }

    public void setPermission(String perm)
    {
        permission = perm;
    }

    public void setSpecialKey(String key)
    {
        this.key = key;
    }

    public void setResult(ItemStack is)
    {
        result = is;
    }

    public void setEffect(BowEffect e)
    {
        effect = e;
    }

    public void setImpactSound(Sound s)
    {
        impactSound = s;
    }

    public void setImpactEffect(Effect eff)
    {
        impactEffect = eff;
    }

    public void setImpactPotion(PotionEffectType eff)
    {
        impactPotion = eff;
    }

    public void setEntitiesToShoot(List<Entity> entities)
    {
        toShootList = entities;
    }

    public void setEntityToShoot(EntityType e)
    {
        toShoot = e;
    }

    public void setEntityToSpawnOnImpact(EntityType e)
    {
        toSpawnOnImpact = e;
    }

    public void createRecipe()
    {
        recipe = new ShapedRecipe(getAsItem());
    }

    public void addRecipe()
    {
        Bukkit.getServer().addRecipe(recipe);
    }

    public void setIngredient(char c, Material ing)
    {
        this.recipe.setIngredient(c, ing);
    }

    // =============================================================================================

    @Override
    public void executeShoot(ProjectileLaunchEvent e)
    {
        switch (effect)
        {
        case SHOOT_ENTITIES:
            break;
        case SHOOT_ENTITY:
            if (toShoot.equals(EntityType.ENDER_PEARL))
            {
                e.setCancelled(true);
                e.getEntity().getShooter().launchProjectile(EnderPearl.class).setVelocity(e.getEntity().getVelocity());
                return;
            } else if (toShoot.equals(EntityType.WITHER_SKULL))
            {
                e.setCancelled(true);
                e.getEntity().getShooter().launchProjectile(WitherSkull.class).setVelocity(e.getEntity().getVelocity());
                return;
            }
            break;
        default:
            break;
        }
    }

    @Override
    public void executeHit(ProjectileHitEvent e)
    {
        switch (effect)
        {
        case EXPLODE_ON_IMPACT:
            e.getEntity().getWorld().createExplosion(e.getEntity().getLocation(), 1.0F, true);
            break;
        case HEAL_HIT_ENTITY:
            for (Entity eee : e.getEntity().getNearbyEntities(1, 1, 1))
            {
                if (eee instanceof LivingEntity)
                {
                    ((LivingEntity) eee).setHealth(20);
                }
            }
            break;
        case KILL_HIT_ENTITY:
            for (Entity eee : e.getEntity().getNearbyEntities(1, 1, 1))
            {
                if (eee instanceof LivingEntity)
                {
                    ((LivingEntity) eee).setHealth(0);
                }
            }
            break;
        case PLAY_EFFECT_ON_IMPACT:
            e.getEntity().getWorld().playEffect(e.getEntity().getLocation(), impactEffect, 1, 20);
            break;
        case PLAY_SOUND_ON_IMPACT:
            e.getEntity().getWorld().playSound(e.getEntity().getLocation(), impactSound, 1.0F, 1.0F);
            break;
        case POTION_HIT_ENTITY:
            for (Entity eee : e.getEntity().getNearbyEntities(1, 1, 1))
            {
                if (eee instanceof LivingEntity)
                {
                    ((LivingEntity) eee).addPotionEffect(new PotionEffect(impactPotion, 1, 100, true));
                }
            }
            break;
        case POTION_NEARBY_ENTITIES:
            for (Entity eee : e.getEntity().getNearbyEntities(1, 1, 1))
            {
                if (eee instanceof LivingEntity)
                {
                    ((LivingEntity) eee).addPotionEffect(new PotionEffect(impactPotion, 1, 100, true));
                }
            }
            break;
        case SPAWN_ENTITY_ON_IMPACT:
            e.getEntity().getWorld().spawnEntity(e.getEntity().getLocation(), toSpawnOnImpact);
            break;
        default:
            break;
        }
    }

    public ItemStack getAsItem()
    {
        ItemStack i = this.getResult();
        ItemMeta meta = i.getItemMeta();
        meta.setDisplayName(this.getName().replace("&", ""));
        meta.setLore(Arrays.asList(ChatColor.BLUE + "" + ChatColor.BOLD + "--MoarStuff BOW--", "", this.getSpecialKey().toLowerCase()));
        i.setItemMeta(meta);
        return i;
    }

    // =============================================================================================

}
