
package me.zeus.MoarStuff.Resource;


import java.util.Arrays;
import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.event.player.PlayerItemConsumeEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.inventory.ShapelessRecipe;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import me.zeus.MoarStuff.Enumeration.FoodEffect;
import me.zeus.MoarStuff.Interfaces.FoodMethod;



public class MSFood implements FoodMethod {

    // =============================================================================================

    private String name;
    private String fileName;
    private String permission;
    private String key;

    private FoodEffect effect;
    private ItemStack result;
    private ShapelessRecipe recipe;
    private ShapedRecipe recipe1;
    private int recipeType;

    private PotionEffectType potionEffect;
    private int potionLevel;
    private int potionDuration;
    private List<PotionEffectType> potionEffects;

    private ItemStack itemGive;
    private int expToGive;
    private Sound sound;
    private int toDamage;
    private boolean kill;

    // =============================================================================================

    public MSFood(String name)
    {
        this.name = name;
        fileName = name;
    }

    // =============================================================================================

    //!format
    public String getName(){ return name; }
    public String getFileName(){ return fileName; }
    public String getPermission(){ return permission; }
    public String getSpecialKey(){ return key; }
    public FoodEffect getEffect(){ return effect; }
    public ItemStack getResult(){ return result; }
    public ShapelessRecipe getShapelessRecipe(){ return recipe; }
    public ShapedRecipe getShapedRecipe(){ return recipe1; }
    public int getRecipeType(){ return recipeType; }
    public PotionEffectType getPotionEffect(){ return potionEffect; }
    public int getPotionLevel(){ return potionLevel; }
    public int getPotionDuration(){ return potionDuration; }
    public List<PotionEffectType>getPotionEffects(){ return potionEffects; }
    public ItemStack getItemToGive(){ return itemGive; }
    public int getExpToGive(){ return expToGive; }
    public Sound getSound(){ return sound; }
    public int getDamageToPlayer(){ return toDamage; }
    public boolean getKillPlayer(){ return kill; }
    //format

    // =============================================================================================

    //!format
    public void setName(String str){ this.name = str; }
    public void setFileName(String str){ this.fileName = str; }
    public void setPermission(String str){ this.permission = str; }
    public void setKey(String str){ this.key = str; }
    public void setEffect(FoodEffect e){ this.effect = e; }
    public void setResult(ItemStack is){ this.result = is; }
    public void setShapelessRecipe(ShapelessRecipe r){ this.recipe = r; }
    public void setShapedRecipe(ShapedRecipe r){ this.recipe1 = r; }
    public void setRecipeType(int abc){ this.recipeType = abc; }
    public void setPotionEffect(PotionEffectType po){ this.potionEffect = po; }
    public void setPotionEffects(List<PotionEffectType>fx){ this.potionEffects = fx; }
    public void setItemToGive(ItemStack is){ this.itemGive = is; }
    public void setExpToGive(int abc){ this.expToGive = abc; }
    public void setSound(Sound s){ this.sound = s; }
    public void setDamageToPlayer(int amt){ this.toDamage = amt; }
    public void setKillPlayer(boolean b){ this.kill = b; }
    public void setPotionLevel(int abc){ this.potionLevel = abc; }
    public void setPotionDuration(int dur){ this.potionDuration = dur; }
    //format

    public void setIngredient(char a, Material mat)
    {
        if (recipeType == 2)
        {
            recipe1.setIngredient(a, mat);
        } else if (recipeType == 1)
        {
            recipe.addIngredient(mat);
        }
    }

    public void createRecipe()
    {
        if (recipeType == 2)
        {
            recipe1 = new ShapedRecipe(getAsItem());
        } else if (recipeType == 1)
        {
            recipe = new ShapelessRecipe(getAsItem());
        }
    }

    public void addRecipe()
    {
        if (recipeType == 2)
        {
            Bukkit.getServer().addRecipe(recipe1);
        } else if (recipeType == 1)
        {
            Bukkit.getServer().addRecipe(recipe);
        }
    }

    // =============================================================================================

    @Override
    public void execute(PlayerItemConsumeEvent e)
    {
        switch (effect)
        {
        case DAMAGE:
            e.getPlayer().damage(toDamage);
            break;
        case GIVE_EXP:
            e.getPlayer().giveExp(expToGive);
            break;
        case GIVE_ITEM:
            e.getPlayer().getInventory().addItem(itemGive);
            break;
        case KILL:
            e.getPlayer().setHealth(0);
            break;
        case POTION:
            e.getPlayer().addPotionEffect(new PotionEffect(potionEffect, potionDuration * 20, potionLevel));
            break;
        case POTIONS:
            for (PotionEffectType eff : potionEffects)
            {
                e.getPlayer().addPotionEffect(new PotionEffect(eff, potionDuration * 20, potionLevel));
            }
            break;
        }
    }

    public ItemStack getAsItem()
    {
        ItemStack i = this.getResult();
        ItemMeta meta = i.getItemMeta();
        meta.setDisplayName(this.getName().replace("&", ""));
        meta.setLore(Arrays.asList(ChatColor.GREEN + "" + ChatColor.BOLD + "--MoarStuff FOOD--", "", this.getSpecialKey().toLowerCase()));
        i.setItemMeta(meta);
        return i;
    }

    // =============================================================================================

}
