
package me.zeus.MoarStuff.Resource;


import java.util.Arrays;

import me.zeus.MoarStuff.Enumeration.FishEffect;
import me.zeus.MoarStuff.Interfaces.FishMethod;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.event.player.PlayerFishEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.inventory.meta.ItemMeta;



public class MSRod implements FishMethod {

    // =============================================================================================

    private String name;
    private String fileName;
    private String permission;
    private String key;

    private ItemStack result = new ItemStack(Material.FISHING_ROD, 1);
    private ShapedRecipe recipe;
    private FishEffect effect;

    private ItemStack toDrop;
    private int expToDrop;

    // =============================================================================================

    public MSRod(String name)
    {
        this.name = name;
        fileName = name;
    }

    // =============================================================================================

    public String getName()
    {
        return name;
    }

    public String getFileName()
    {
        return fileName;
    }

    public String getPermission()
    {
        return permission;
    }

    public String getSpecialKey()
    {
        return key;
    }

    public ItemStack getResult()
    {
        return result;
    }

    public ShapedRecipe getRecipe()
    {
        return recipe;
    }

    public FishEffect getEffect()
    {
        return effect;
    }

    public ItemStack getItemToDrop()
    {
        return toDrop;
    }

    public int getExpToDrop()
    {
        return expToDrop;
    }

    // =============================================================================================

    public void setName(String name)
    {
        this.name = name;
    }

    public void setFileName(String name)
    {
        fileName = name;
    }

    public void setPermission(String perm)
    {
        permission = perm;
    }

    public void setSpecialKey(String key)
    {
        this.key = key;
    }

    public void setIngredient(char c, Material m)
    {
        recipe.setIngredient('C', m);
    }

    public void setResult(ItemStack i)
    {
        result = i;
    }

    public void setEffect(FishEffect eff)
    {
        effect = eff;
    }

    public void setItemToDrop(ItemStack i)
    {
        toDrop = i;
    }

    public void setExpToDrop(int amount)
    {
        expToDrop = amount;
    }

    public void createRecipe()
    {
        recipe = new ShapedRecipe(getAsItem());
    }

    public void addRecipe()
    {
        Bukkit.getServer().addRecipe(recipe);
    }

    // =============================================================================================

    @Override
    public void execute(PlayerFishEvent e)
    {
        switch (effect)
        {
        case DROP_ITEM:
            e.getPlayer().getWorld().dropItemNaturally(e.getPlayer().getLocation(), toDrop);
            break;
        case DROP_ITEMS:
            break;
        case GIVE_EXP:
            e.getPlayer().giveExp(expToDrop);
            break;
        default:
            break;
        }
    }

    public ItemStack getAsItem()
    {
        ItemStack i = this.getResult();
        ItemMeta meta = i.getItemMeta();
        meta.setDisplayName(this.getName().replace("&", ""));
        meta.setLore(Arrays.asList(ChatColor.GREEN + "" + ChatColor.BOLD + "--MoarStuff ROD--", "", this.getSpecialKey().toLowerCase()));
        i.setItemMeta(meta);
        return i;
    }

    // =============================================================================================

}
