
package me.zeus.MoarStuff.Util;


import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import me.zeus.MoarStuff.MoarStuff;
import me.zeus.MoarStuff.Enumeration.BowEffect;
import me.zeus.MoarStuff.Resource.MSBow;

import org.bukkit.Effect;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.EntityType;
import org.bukkit.potion.PotionEffectType;



public class BowReader {

    @SuppressWarnings("unused")
    private MoarStuff plugin;
    public boolean loaded = false;
    public File file;
    public String bowType;
    public MSBow bow;

    public BowReader(MoarStuff plugin, File file, String string)
    {
        this.plugin = plugin;
        this.file = file;
        bowType = string;
        bow = new MSBow(file.getName());
        bow.setFileName(file.getName().toLowerCase());
        load();
    }

    private void computeData(String str)
    {
        try
        {
            if (str.indexOf("=") > 0)
            {
                String var = str.substring(0, str.indexOf("=")).toLowerCase();
                String val = str.substring(str.indexOf("=") + 1);
                // lots of if, then statements
                if (var.equals("bow-name"))
                {
                    bow.setName(val);
                }
                if (var.equals("permission"))
                {
                    bow.setPermission(val);
                }
                if (var.equals("key"))
                {
                    bow.setSpecialKey(val);
                }
                if (var.equals("init-recipe-a"))
                {
                    if (Boolean.parseBoolean(val) == true)
                    {
                        bow.createRecipe();
                    }
                }
                if (var.equals("recipe-shape"))
                {
                    String[] ss = val.toString().split(",");
                    bow.getRecipe().shape(ss[0], ss[1], ss[2]);
                }
                if (var.equals("recipe-ingredient-a"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('A', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-b"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('B', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-c"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('C', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-d"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('D', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-e"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('E', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-f"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('F', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-g"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('G', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-h"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('H', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-i"))
                {
                    if (!val.equals("null"))
                    {
                        bow.getRecipe().setIngredient('I', Material.valueOf(val));
                    }
                }
                if (var.equals("init-recipe-b"))
                {
                    if (Boolean.parseBoolean(val) == true)
                    {
                        bow.addRecipe();
                    }
                }
                if (var.equals("effect"))
                {
                    if (!val.equals("null"))
                    {
                        bow.setEffect(BowEffect.valueOf(val));
                    }
                }
                if (var.equals("impact-effect"))
                {
                    if (!val.equals("null"))
                    {
                        bow.setImpactEffect(Effect.valueOf(val));
                    }
                }
                if (var.equals("impact-potion"))
                {
                    if (!val.equals("null"))
                    {
                        bow.setImpactPotion(PotionEffectType.getByName(val));
                    }
                }
                if (var.equals("impact-sound"))
                {
                    if (!val.equals("null"))
                    {
                        bow.setImpactSound(Sound.valueOf(val));
                    }
                }
                if (var.equals("entity-to-shoot"))
                {
                    if (!val.equals("null"))
                    {
                        bow.setEntityToShoot(EntityType.valueOf(val));
                    }
                }
                if (var.equals("entity-to-spawn-impact"))
                {
                    if (!val.equals("null"))
                    {
                        bow.setEntityToSpawnOnImpact(EntityType.valueOf(val));
                    }
                }

            }
        } catch (Exception e)
        {
            loaded = false;
            e.printStackTrace();
        }
    }

    public void load()
    {
        loaded = true;
        ArrayList<String> file = new ArrayList<String>();
        try
        {
            FileInputStream fstream = new FileInputStream(this.file.getAbsolutePath());
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String strLine;
            while ((strLine = br.readLine()) != null)
            {
                file.add(strLine);
            }
            br.close();
            in.close();
            fstream.close();
        } catch (Exception e)
        {
            System.err.println("Error: " + e.getMessage());
        }

        for (int i = 0; i < file.size(); i++)
        {
            computeData(file.get(i));
        }
    }

}
