
package me.zeus.MoarStuff.Util;


import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import me.zeus.MoarStuff.MoarStuff;
import me.zeus.MoarStuff.Enumeration.FoodEffect;
import me.zeus.MoarStuff.Resource.MSFood;

import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.inventory.ItemStack;
import org.bukkit.potion.PotionEffectType;



public class FoodReader {

    @SuppressWarnings("unused")
    private MoarStuff plugin;
    public boolean loaded = false;
    public File file;
    public String foodType;
    public MSFood food;

    public FoodReader(MoarStuff plugin, File file, String string)
    {
        this.plugin = plugin;
        this.file = file;
        foodType = string;
        food = new MSFood(file.getName());
        food.setFileName(file.getName().toLowerCase());
        load();
    }

    public void load()
    {
        loaded = true;
        ArrayList<String> file = new ArrayList<String>();
        try
        {
            FileInputStream fstream = new FileInputStream(this.file.getAbsolutePath());
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String strLine;
            while ((strLine = br.readLine()) != null)
            {
                file.add(strLine);
            }
            br.close();
            in.close();
            fstream.close();
        } catch (Exception e)
        {
            System.err.println("Error: " + e.getMessage());
        }

        for (int i = 0; i < file.size(); i++)
        {
            computeData(file.get(i));
        }
    }

    private void computeData(String str)
    {
        try
        {
            if (str.indexOf("=") > 0)
            {
                String var = str.substring(0, str.indexOf("=")).toLowerCase();
                String val = str.substring(str.indexOf("=") + 1);
                // lots of if, then statements
                if (var.equals("food-name"))
                {
                    food.setName(val);
                }
                if (var.equals("permission"))
                {
                    food.setPermission(val);
                }
                if (var.equals("key"))
                {
                    food.setKey(val);
                }
                if (var.equals("effect"))
                {
                    food.setEffect(FoodEffect.valueOf(val));
                }
                if (var.equals("crafting-result"))
                {
                    String[] ss = val.toString().split(",");
                    ItemStack is = new ItemStack(Material.valueOf(ss[0]), Integer.parseInt(ss[1]));
                    food.setResult(is);
                }
                if (var.equals("recipe-type"))
                {
                    food.setRecipeType(Integer.parseInt(val));
                }
                if (var.equals("init-recipe-a"))
                {
                    if (Boolean.parseBoolean(val) == true)
                    {
                        food.createRecipe();
                    }
                }
                if (var.equals("shaped-recipe-shape"))
                {
                    if (!val.equals("null"))
                    {
                        String[] ss = val.toString().split(",");
                        food.getShapedRecipe().shape(ss[0], ss[1], ss[2]);
                    }
                }
                //==================== SHAPELESS STUFF ============================== \\
                if (var.equals("shapeless-ingredient-a"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('A', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-b"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('B', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-c"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('C', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-d"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('D', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-e"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('E', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-f"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('F', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-g"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('G', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-h"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('H', Material.valueOf(val));
                    }
                }
                if (var.equals("shapeless-ingredient-i"))
                {
                    if (!val.equals("null"))
                    {
                        food.setIngredient('I', Material.valueOf(val));
                    }
                }
                //==================== SHAPED STUFF ============================== \\
                if (var.equals("shaped-ingredient-a"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('A', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-b"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('B', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-c"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('C', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-d"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('D', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-e"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('E', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-f"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('F', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-g"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('G', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-h"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('H', Material.valueOf(val));
                    }
                }
                if (var.equals("shaped-ingredient-i"))
                {
                    if (!val.equals("null"))
                    {
                        food.getShapedRecipe().setIngredient('I', Material.valueOf(val));
                    }
                }
                // ============================================================ \\
                if (var.equals("init-recipe-b"))
                {
                    if (Boolean.parseBoolean(val) == true)
                    {
                        food.addRecipe();
                    }
                }
                // ============================================================ \\
                if (var.equals("potion-duration"))
                {
                    food.setPotionDuration(Integer.parseInt(val));
                }
                if (var.equals("potion-level"))
                {
                    food.setPotionLevel(Integer.parseInt(val));
                }
                if (var.equals("potion-effect"))
                {
                    food.setPotionEffect(PotionEffectType.getByName(val));
                }
                if (var.equals("potion-effects"))
                {
                    if (!val.equals("null"))
                    {
                        List<String> values = Arrays.asList(val);
                        for (PotionEffectType pet : PotionEffectType.values())
                        {
                            if (values.contains(pet.toString()))
                            {
                                food.getPotionEffects().add(pet);
                            }
                        }
                    }
                }
                if (var.equals("item-to-give"))
                {
                    if (!val.equals("null"))
                    {
                        String[] ss = val.toString().split(",");
                        ItemStack is = new ItemStack(Material.valueOf(ss[0]), Integer.parseInt(ss[1]));
                        food.setItemToGive(is);
                    }
                }
                if (var.equals("exp-to-give"))
                {
                    food.setExpToGive(Integer.parseInt(val));
                }
                if (var.equals("sound"))
                {
                    if (!val.equals("null"))
                    {
                        food.setSound(Sound.valueOf(val));
                    }
                }
                if (var.equals("damage-to-player"))
                {
                    food.setDamageToPlayer(Integer.parseInt(val));
                }
                if (var.equals("kill-player"))
                {
                    food.setKillPlayer(Boolean.parseBoolean(val));
                }
            }
            // ============================================================ \\

        } catch (Exception e)
        {
            loaded = false;
            e.printStackTrace();
        }
    }
}
