
package me.zeus.MoarStuff.Util;


import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import me.zeus.MoarStuff.MoarStuff;
import me.zeus.MoarStuff.Enumeration.FishEffect;
import me.zeus.MoarStuff.Resource.MSRod;

import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;



public class RodReader {

    @SuppressWarnings("unused")
    private MoarStuff plugin;
    public boolean loaded = false;
    public File file;
    public String rodType;
    public MSRod rod;

    public RodReader(MoarStuff plugin, File file, String string)
    {
        this.plugin = plugin;
        this.file = file;
        rodType = string;
        rod = new MSRod(file.getName());
        rod.setFileName(file.getName().toLowerCase());
        load();
    }

    private void computeData(String str)
    {
        try
        {
            if (str.indexOf("=") > 0)
            {
                String var = str.substring(0, str.indexOf("=")).toLowerCase();
                String val = str.substring(str.indexOf("=") + 1);
                // lots of if, then statements
                if (var.equals("rod-name"))
                {
                    rod.setName(val);
                }
                if (var.equals("permission"))
                {
                    rod.setPermission(val);
                }
                if (var.equals("key"))
                {
                    rod.setSpecialKey(val);
                }
                if (var.equals("init-recipe-a"))
                {
                    if (Boolean.parseBoolean(val) == true)
                    {
                        rod.createRecipe();
                    }
                }
                if (var.equals("recipe-shape"))
                {
                    String[] ss = val.toString().split(",");
                    rod.getRecipe().shape(ss[0], ss[1], ss[2]);
                }
                if (var.equals("recipe-ingredient-a"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('A', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-b"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('B', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-c"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('C', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-d"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('D', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-e"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('E', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-f"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('F', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-g"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('G', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-h"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('H', Material.valueOf(val));
                    }
                }
                if (var.equals("recipe-ingredient-i"))
                {
                    if (!val.equals("null"))
                    {
                        rod.getRecipe().setIngredient('I', Material.valueOf(val));
                    }
                }
                if (var.equals("init-recipe-b"))
                {
                    if (Boolean.parseBoolean(val) == true)
                    {
                        rod.addRecipe();
                    }
                }
                if (var.equals("effect"))
                {
                    rod.setEffect(FishEffect.valueOf(val));
                }
                if (var.equals("drop-item"))
                {
                    if (!val.equals("null"))
                    {
                        String[] ss = val.toString().split(",");
                        rod.setItemToDrop(new ItemStack(Material.valueOf(ss[0]), Integer.parseInt(ss[1])));
                    }
                }
                if (var.equals("drop-exp"))
                {
                    rod.setExpToDrop(Integer.parseInt(val));
                }

            }
        } catch (Exception e)
        {
            loaded = false;
        }
    }

    public void load()
    {
        loaded = true;
        ArrayList<String> file = new ArrayList<String>();
        try
        {
            FileInputStream fstream = new FileInputStream(this.file.getAbsolutePath());
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String strLine;
            while ((strLine = br.readLine()) != null)
            {
                file.add(strLine);
            }
            br.close();
            in.close();
            fstream.close();
        } catch (Exception e)
        {
            System.err.println("Error: " + e.getMessage());
        }

        for (int i = 0; i < file.size(); i++)
        {
            computeData(file.get(i));
        }
    }

}
